%------------------------------------------------------------------------------
\section{Messages}
%------------------------------------------------------------------------------

\paragraph{Usage}

\begin{verbatim}
ghci -Wall -package rh Message.lhs
\end{verbatim}

%if False
%- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
\subsection{Module header}
%- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

%endif

> module Message (module Message, module PrettierNG)
> where
> import PrettierNG

%-------------------------------------------------------------------------------
\section{Type definitions}
%-------------------------------------------------------------------------------

> data Message  =  Title     Doc
>               |  Subtitle  Doc
>               |  Debug     Doc
>               |  Warning   Doc
>               |  Error     Doc
>                  deriving (Show)

> instance Pretty Message where
>   prettyPrec _ (Title     d)  =  title ">>>"  d
>   prettyPrec _ (Subtitle  d)  =  title ">> "  d
>   prettyPrec _ (Debug     d)  =  d
>   prettyPrec _ (Warning   d)  =  title "***"  d
>   prettyPrec _ (Error     d)  =  title "***"  d
>
>   prettyList ms  =  intersperse nl (map pretty ms)
>
> --title s d  =  block (length s + 1) (text s <> sp <> d)
> title s d  =  block 4 (text (s ++ " ") <> d)
>
> data Pass aT  =  Fail [Message]
>               |  Succeed aT  [Message]
>                  deriving (Show)

%-------------------------------------------------------------------------------
\section{Support for color coding}
%-------------------------------------------------------------------------------

> red, blue, magenta, underline, nounderline, reset, gray, bold, normal :: Doc
> red          =  escape (BrightForeground Red    )
> blue         =  escape (BrightForeground Blue   )
> magenta      =  escape (BrightForeground Magenta)
> gray         =  escape (BrightForeground Black  )
> underline    =  escape Underline
> nounderline  =  escape NoUnderline
> bold         =  escape Bold
> normal       =  escape Normal
> reset        =  escape Reset

Logical markup:

> astype, askind, ascon, asexpr, askeyword, asprompt :: Doc -> Doc
> astype d     =  red <> d <> reset
> askind d     =  magenta <> d <> red 
> asexpr d     =  reset <> d
> ascon d      =  blue <> d <> reset 
> askeyword d  =  bold <> d <> normal 
> asprompt d   =  gray <> d <> reset
